Name: samesame
Version: 1.3
Release: 0
URL: http://samesame.kruijff.org/
Source: http://samesame.kruijff.org/%{name}-%{version}.tar.bz2
License: BSD (2 Clauses), Copyright (c) 2009 Alex de Kruijff
Group: Applications/File
Summary: Find identical files and optionally link them together

%description
SameSame is a collection of tools that fall in to the category of file management software. These tools will prevent that you need to delete files or buy more disk space. Instead they solve low disk space problems by linking identical files together and thus free up waisted disk space.

This collection was inspired by the application samefile written by Jens Schweikhardt. The collection comes with its own version of samefile that is noticeable faster and is able to process a much larger file list. Samefile is the duplicate file finder and combined with samelink it acts as a duplicate file remover.

This port contains the applications: samefile, samelink and samearchive. The latter does the same as samefile but for file-based archives. The port also contains a version that uses just 10% of the resources compared to samearchive. The application samelink hard link identical files for you.

Typical usage would be: find / | samefile -i | samelink. This would search for identical files and clean up wasted disk space by linking them together. Add the option -vn after samelink for a verbose dry-run.

%prep
%setup

%build
%configure
make

%install
%makeinstall

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-, root, root, 0755)
%doc INSTALL README
%doc %{_mandir}/man1/samefile.1*
%doc %{_mandir}/man1/samelink.1*
%doc %{_mandir}/man1/samearchive.1*
%doc %{_mandir}/man1/samearchive-lite.1*
%{_prefix}/bin/samefile
%{_prefix}/bin/samelink
%{_prefix}/bin/samearchive
%{_prefix}/bin/samearchive-lite

